<?php

$dbConnection = null;

//require_once('lib/adodb510/adodb-exceptions.inc.php');
//require_once('lib/adodb510/adodb.inc.php');

//require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb511/adodb-exceptions.inc.php');
//require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb511/adodb.inc.php');

require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb514/adodb-exceptions.inc.php');
require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb514/adodb.inc.php');

class Database extends Module 
{

	function __construct() {
		parent::__construct();
	}

	//use the namespace as a specific database name key
	function module_init( $moduleNamespace) {

		global $site;
		global $dataCollector;

		$databaseFound = false;

		//load database config from env data:
		if( isset( $dataCollector['environment']['database'] ) && !empty( $dataCollector['environment']['database']) ) {
			//USING OLD DATABASE STYLE JSON DATA STRUCTURE
			
			$databaseFound = true;
			$this->getDBConnection( 
				$dataCollector['environment']['database']['database_type'],
				$dataCollector['environment']['database']['host'],
				$dataCollector['environment']['database']['username'],
				$dataCollector['environment']['database']['password'],
				$dataCollector['environment']['database']['schema']
			);

		} elseif( isset( $dataCollector['environment']['databases'] ) && !empty( $dataCollector['environment']['databases']) ) {
			//USING NEW DATA STYLE JSON STRUCTURE:
			//if a particular database is not specified, will have to look for the 'default schema'

			if( isset( $moduleNamespace) && !empty( $moduleNamespace) ) {
				//ok, we've been given a particular schema name.
		 		$databaseName = $moduleNamespace;
		 		
		 		if( isset( $dataCollector['environment']['databases'][ $databaseName]) ) {
		 			
		 			//great, that schema exists.
		 			$databaseFound = true;
					$this->getDBConnection( 
						$dataCollector['environment']['databases'][$databaseName]['database_type'],
						$dataCollector['environment']['databases'][$databaseName]['host'],
						$dataCollector['environment']['databases'][$databaseName]['username'],
						$dataCollector['environment']['databases'][$databaseName]['password'],
						$dataCollector['environment']['databases'][$databaseName]['schema']
					);
		 		}
			 		
			} else {
				//we dont have a database schema, we've have to iterate and look for a default schema:
				
				$defaultDatabaseDefinition = null;
				foreach( $dataCollector['environment']['databases'] as $databaseName => $databaseDefinition) {
					if( $databaseDefinition['is_default_schema'] ) {
		 				$databaseFound = true;
						$defaultDatabaseDefinition = $databaseDefinition;
						break;
					}
				}
				
				if( $databaseFound) {
					$this->getDBConnection( 
						$defaultDatabaseDefinition['database_type'],
						$defaultDatabaseDefinition['host'],
						$defaultDatabaseDefinition['username'],
						$defaultDatabaseDefinition['password'],
						$defaultDatabaseDefinition['schema']
					);
				}

			}
			
			
		} else {
			//echo 'site DATABASE_ENABLED, but enviroment database connection details not found.';
		}
	
		if( !$databaseFound) {
			logMessage('No Database Configuration could be found.');
		}
	
	}


	public function getDAO( $daoName) {

		//global $dbConnection;

//		if( !$this->isCached( $daoName) ) {

			global $SITE_LOCATION;
			$daoSciptName = $SITE_LOCATION . '/daos/' . $daoName . '.php';
			
			//if( !file_exists( "model-daos/$daoName.php") ) {
			if( !file_exists( $daoSciptName) ) {
				//invalid DAO name. dont continue.
				//should probably through an exception or something...
				return null;				
			}
			
			global $CONTENTIGO_HOME;
			require_once( $CONTENTIGO_HOME . '/modules/Database/DAO.php');
			require_once( $daoSciptName);
			$newDao = new $daoName();
			//$newDao->setDBConnection( $dbConnection);
			//$newDao->setDAOFactory( $this);
			$this->daoMap[ $daoName] = &$newDao;
//		}

		return $this->daoMap[ $daoName];
	}

	public function isCached( $daoName) {
		if( isset( $this->daoMap[ $daoName])) {
			return true; 
		}
		return false;
	}


	public function getDBConnection( $dbType, $host, $username, $password, $schema) {

		//attempt to close the connection
		$this->closeConnection();

		global $dbConnection;

		try {
		
			//setup a database connection
			$dbConnection = NewADOConnection( $dbType);
			$dbConnection->Connect(	$host, $username, $password, $schema);
			
		} catch (Exception $e) {
			//echo( "CATCH");
			//var_dump($e); 
		}
			//adodb_backtrace($e->gettrace());

		//to this by default:
		$dbConnection->SetFetchMode( ADODB_FETCH_ASSOC);
	}	


	public static function &getConnection() {
		global $dbConnection;
		
		if( !$dbConnection->IsConnected() ) {
			//Logger::Log('connection gone: closing...');
			$dbConnection->close();
			//Logger::Log('connection gone: reconnecting...');
			//DAOFactory::getDatabaseConnection('database');
			return false; 
		}		
		return $dbConnection;
	}
	
	public static function closeConnection() {
		global $dbConnection;
		if( !empty( $dbConnection)) {
			$result = $dbConnection->Close();
		} else {
			//already closed - by PHP? or just empty
		}
	} 
	
	function __destruct() {
		//DAOFactory::closeConnection();
		$this->closeConnection();
	}
	
}
?>